/**
 ******************************************************************************
 * Copyright (c), Takenori Imoto
 *  software http://www.kaede-software.com/
 * All rights reserved.
 ******************************************************************************
 * \[XR[h`oCi`AύX邩Ȃ킸Aȉ̏
 * ꍇɌAĔЕzюgp܂B
 *
 * E\[XR[hĔЕzꍇAL̒쌠\A{ꗗAщLƐ
 *   ܂߂邱ƁB
 * EoCi`ōĔЕzꍇAЕzɕt̃hLg̎ɁAL
 *   쌠\A{ꗗAщLƐӏ܂߂邱ƁB
 * Eʂɂʂ̋ȂɁA{\tgEFAhi̐`܂͔̔
 *   iɁAgD̖O܂̓Rgr[^[̖OgpĂ͂ȂȂB
 *
 * {\tgEFÁA쌠҂уRgr[^[ɂāû܂܁v
 * ĂAَ킸AƓIȎgp\Aѓ̖ړIɑ΂K
 * ɊւÖق̕ۏ؂܂߁A܂Ɍ肳ȂAȂۏ؂܂
 * B쌠҂Rgr[^[AR̂킸AQ̌
 * 킸AӔC̍_ł邩iӔCł邩iߎ̑́js@
 * sׂł邩킸Aɂ̂悤ȑQ\m炳ĂƂ
 * ĂA{\tgEFA̎gpɂĔi֕i܂͑pT[rX̒BA
 * gp̑rAf[^̑rAv̑rAƖ̒f܂߁A܂Ɍ肳
 * jڑQAԐڑQAIȑQAʑQAIQA܂͌ʑQ
 * āAؐӔC𕉂Ȃ̂Ƃ܂B
 ******************************************************************************
 * {\tgEFÁAgg2 ( http://kikyou.info/tvp/ ) ̃\[XR[hJava
 * ɏ̂ꕔgpĂ܂B
 * gg2 Copyright (C) W.Dee <dee@kikyou.info> and contributors
 ******************************************************************************
 */
package jp.kirikiri.tvp2.base;

import java.util.HashMap;

import jp.kirikiri.tjs2.TJSException;
import jp.kirikiri.tvp2.TVP;
import jp.kirikiri.tvp2.msg.Message;

public class ArchiveCache {
	static private final int DEFAULT_ARCHIVE_CACHE_NUM = 64;

	private HashMap<String,Archive> mArchiveCache;

	public ArchiveCache() {
		mArchiveCache = new HashMap<String,Archive>(DEFAULT_ARCHIVE_CACHE_NUM);
	}

	/*
	public void setMaxCount( int maxcount ) {
		//ArchiveCache.setMaxCount(maxcount);
	}
	*/

	void clear() {
		// releases all elements
		mArchiveCache.clear();
	}

	Archive get( final String name ) throws TJSException {
		String nname = TVP.StorageMediaManager.normalizeStorageName(name,null);
		synchronized (this) {
			Archive ptr = mArchiveCache.get(nname);
			if( ptr != null ) {
				// exist in the cache
				return ptr;
			}

			if( !Storage.isExistentStorageNoSearch(nname) )
			{
				// storage not found
				Message.throwExceptionMessage( Message.CannotFindStorage, nname );
			}

			// not exist in the cache
			Archive arc = TVP.openArchive(nname);
			mArchiveCache.put(nname,arc);
			return arc;
		}
	}
}
